%{!?scl:%global pkg_name %{name}}
%{?scl:%scl_package rubygem-%{gem_name}}
%global	gem_name	json
%global	rubyabi	1.9.1

Name:           %{?scl_prefix}rubygem-%{gem_name}
Version:        1.7.3
Release:        5%{?dist}

Summary:        A JSON implementation in Ruby

Group:          Development/Languages

License:        Ruby or GPLv2
URL:            http://json.rubyforge.org
Source0:        http://gems.rubyforge.org/gems/%{gem_name}-%{version}.gem
Patch0:         rubygem-json-CVE-2013-0269-denial-of-service.patch

BuildRequires:	%{?scl_prefix}ruby(abi) = %{rubyabi}
BuildRequires:	%{?scl_prefix}ruby-devel
BuildRequires:  %{?scl_prefix}rubygems-devel
BuildRequires:  %{?scl_prefix}rubygem(rake)
BuildRequires:	%{?scl_prefix}rubygem(minitest)
BuildRequires:	%{?scl_prefix}rubygem(bigdecimal)
Requires:       %{?scl_prefix}ruby(abi) = %{rubyabi}
Requires:       %{?scl_prefix}rubygems
Provides:       %{?scl_prefix}rubygem(json) = %{version}

Obsoletes:	%{?scl_prefix}rubygem-%{gem_name}-gui < %{version}
Obsoletes:	%{?scl_prefix}ruby-%{gem_name}-gui < %{version}
Obsoletes:	%{?scl_prefix}ruby-%{gem_name} < %{version}

%description
This is a implementation of the JSON specification according
to RFC 4627 in Ruby.
You can think of it as a low fat alternative to XML,
if you want to store data to disk or transmit it over
a network rather than use a verbose markup language.

%package	doc
Summary:	Documentation for %{pkg_name}
Group:		Documentation

Requires:	%{?scl_prefix}%{pkg_name} = %{version}-%{release}

%description	doc
This package contains documentation for %{pkg_name}.

%prep
%setup -q -c -T
mkdir -p ./%{gem_dir}

# Gem patch and repack
TOPDIR=$(pwd)
mkdir tmpunpackdir
pushd tmpunpackdir

%{?scl:scl enable %scl "}
gem unpack %{SOURCE0}
%{?scl:"}

cd %{gem_name}-%{version}
%patch0 -p1

%{?scl:scl enable %scl "}
gem build %{gem_name}.gemspec
%{?scl:"}

mv %{gem_name}-%{version}.gem $TOPDIR

popd
rm -rf tmpunpackdir

%build
export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
%{?scl:scl enable %scl "}
gem install --local --install-dir .%{gem_dir} -V --force %{gem_name}-%{version}.gem
%{?scl:"}

find . -name \*gem -exec chmod 0644 {} \;

# change cflags to honor Fedora compiler flags correctly
find . -name extconf.rb | xargs sed -i -e 's|-O3|-O2|'
find . -name Makefile | xargs sed -i -e 's|-O3|-O2|'
# compile again
find . -name extconf.rb | while read f
do
	make -C $(dirname $f) clean all install
done

# remove pure
rm -fr .%{gem_instdir}/lib/json/pure*

%install
mkdir -p $RPM_BUILD_ROOT%{gem_dir}
mkdir -p $RPM_BUILD_ROOT%{gem_extdir}/lib/%{gem_name}
 
cp -a .%{gem_dir}/* %{buildroot}/%{gem_dir}

# Let's move arch dependent files to arch specific directory
mv .%{gem_libdir}/json/ext \
	$RPM_BUILD_ROOT%{gem_extdir}/lib/%{gem_name}

chmod 0644 $RPM_BUILD_ROOT%{gem_instdir}/install.rb
chmod 0644 $RPM_BUILD_ROOT%{gem_instdir}/tests/*.rb
chmod 0644 $RPM_BUILD_ROOT%{gem_instdir}/tools/server.rb
chmod 0644 $RPM_BUILD_ROOT%{gem_instdir}/tools/fuzz.rb

# We don't need those files anymore.
rm -rf $RPM_BUILD_ROOT%{gem_instdir}/ext
rm -rf $RPM_BUILD_ROOT%{gem_instdir}/install.rb
rm -rf $RPM_BUILD_ROOT%{gem_instdir}/{.require_paths,.gitignore,.travis.yml}
rm -rf $RPM_BUILD_ROOT%{gem_instdir}/lib/json/ext/
rm -rf $RPM_BUILD_ROOT%{gem_instdir}/diagrams
rm -rf $RPM_BUILD_ROOT%{gem_docdir}/rdoc/classes/.src
rm -rf $RPM_BUILD_ROOT%{gem_docdir}/rdoc/classes/.html

rm -rf $RPM_BUILD_ROOT%{gem_instdir}/java/

mkdir -p $RPM_BUILD_ROOT%{ruby_libdir}
mkdir -p $RPM_BUILD_ROOT%{ruby_libarchdir}
ln -s %{gem_libdir}/%{gem_name}.rb %{buildroot}%{ruby_libdir}/%{gem_name}.rb
ln -s %{gem_libdir}/%{gem_name} %{buildroot}%{ruby_libdir}/%{gem_name}
ln -s %{gem_extdir}/lib/%{gem_name}/ %{buildroot}%{ruby_libarchdir}/%{gem_name}

%check
pushd .%{gem_instdir}
# copy .so files into proper places for testing
pushd ext/%{gem_name}/ext
cp parser/parser.so .
cp generator/generator.so .
popd

%{?scl: scl enable %scl "}
testrb -Ilib:ext tests/test_*
%{?scl:"}
popd

%files
%doc %{gem_instdir}/[A-Z]*
%dir %{gem_instdir}
%{gem_instdir}/tools/
%{gem_libdir}
%{gem_extdir}
%exclude %{gem_cache}
%{gem_spec}
%{ruby_libdir}/%{gem_name}*
%{ruby_libarchdir}/%{gem_name}

%files doc
%{gem_instdir}/Rakefile
%{gem_instdir}/data
%{gem_instdir}/tests
%{gem_instdir}/*gemspec
%doc %{gem_docdir}


%changelog
* Mon Apr 08 2013 Vít Ondruch <vondruch@redhat.com> - 1.7.3-5
- Install the patched gem.

* Wed Feb 13 2013 Josef Stribny <jstribny@redhat.com> - 1.7.3-4
- Repacking the gem in %%prep bacause of patching.
- Fix for CVE-2013-0269.

* Tue Oct 02 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1.7.3-3
- Fix the tests to actually use newly generated C extensions.

* Tue Jul 31 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1.7.3-2
- Provide the symlinks in %%{ruby_libdir} and %%{ruby_libarchdir}.

* Tue Jul 24 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1.7.3-1
- Update to JSON 1.7.3.
- Specfile cleanup.

* Fri Mar 30 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1.6.6-1
- Rebuilt for scl.
- Updated to 1.6.6.

* Sun Jan 21 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.6.5-1
- 1.6.5

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.6-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.6-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Sep 29 2010 jkeating - 1.4.6-2
- Rebuilt for gcc bug 634757

* Sat Sep 18 2010 Xavier Lamien <laxathom@fedoraproject.org> - 1.4.6-1
- Update release.
- Enabled test stage.

* Fri Jun 11 2010 Xavier Lamien <laxathom@fedoraproject.org> - 1.4.3-3
- Move ruby's site_lib editor to ruby-json-gui.

* Mon May 10 2010 Xavier Lamien <laxathom@fedoraproject.org> - 1.4.3-2
- Move editor out of ruby-json sub-package.

* Sun May 09 2010 Xavier Lamien <laxathom@fedoraproject.org> - 1.4.3-1
- Update release.
- Split-out json editor.

* Thu Oct 29 2009 Xavier Lamien <laxathom@fedoraproject.org> - 1.1.9-1
- Update release.

* Wed Aug 12 2009 Xavier Lamien <laxathom@fedoraproject.org> - 1.1.7-3
- Fix gem scripts and install_dir.
- Enable %%check stage.

* Wed Aug 05 2009 Xavier Lamien <laxathom@fedoraproject.org> - 1.1.7-2
- Rebuild in correct buildir process.
- Add sub packages.

* Mon Aug 03 2009 Xavier Lamien <laxathom@fedoraproject.org> - 1.1.7-1
- Update release.

* Sat Jun 06 2009 Xavier Lamien <laxathom@fedoraproject.org> - 1.1.6-1
- Update release.

* Tue May 12 2009 Xavier Lamien <laxathom@fedoraproject.org> - 1.1.5-1
- Update release.

* Thu Apr 02 2009 Xavier Lamien <laxathom@fedoraproject.org> - 1.1.4-1
- Update release.

* Sat Jul 12 2008 Xavier Lamien <laxathom@fedoraproject.org> - 1.1.3-1
- Initial RPM release.
